% gl_stopcond_pdg - "primal-dual" stopping condition for grouped L1
%                   regularization
%
% Copyright(c) 2009 Ryota Tomioka
% This software is distributed under the MIT license. See license.txt

function [ret, res]=gl_stopcond_pdg(fnc, ww, A, AT, lambda, floss, gg, tol)

vv   = zeros(size(ww));
vv(:)= AT(gg);
nmd  = max(sqrt(sum(vv.^2)));
aa   = min(1,lambda/nmd)*gg;
dloss = fnc.d(aa, fnc.args{:});

nmp  = sum(sqrt(sum(ww.^2)));
fval = floss+lambda*nmp;

res  = (fval-(-dloss))/fval;
ret  = (res<tol);
