% hessMultdalgl - function that computes H*x for DAL with grouped
%                 L1 regularization
%
% Copyright(c) 2009 Ryota Tomioka
% This software is distributed under the MIT license. See license.txt

function yy = hessMultdalgl(xx, A, eta, Hinfo)
ns   =Hinfo.ns;
nc   =Hinfo.nc;
hloss=Hinfo.hloss;
I    =Hinfo.I;
vn   =Hinfo.vn;
ff   =Hinfo.ff;

yy = xx.*hloss;


for kk=1:length(I)
  jj=I(kk);
  iblk=((1:ns)+ns*(jj-1))';
  
  F1 = sparse(iblk,1:ns,ff(kk)*ones(ns,1),ns*nc,ns);
  F2 = sparse(iblk,ones(ns,1),(1-ff(kk))*vn(:,kk),ns*nc,1);
  AF = A(F1)+A(F2)*vn(:,kk)';

  yy = yy + eta*(AF*(AF'*xx));
end

